# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .malwarebytes_credential import MalwarebytesCredential

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class EdrMalwarebytes(pydantic.BaseModel):
    """
    Configuration for the Malwarebytes EDR Provider
    """

    account_identifier: str = pydantic.Field()
    """
    Account identifier for the Malwarebytes EDR Provider. Can be either the account ID directly (e.g. xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx) or the full tenant URL (e.g. https://cloud.malwarebytes.com/xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx/dashboard)
    """

    credential: MalwarebytesCredential
    url: typing.Optional[str] = pydantic.Field(default=None)
    """
    URL for the Malwarebytes EDR Provider
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
